<?php
/*
* Send SMS text as $message to abonents in $arr_phone (array or string) from senders in $arr_sender (array or string), use array $arr_config
* Delivery time in seconds, no more than 172800 (48 hrs), usually 86400 (24h)
*
* @param array $arr_config
* @param mixed $arr_phone
* @param mixed $arr_sender
* @param string $message
* @param int $validity_period
* 
* @return string
*/

function send_sms ($arr_config,$arr_phone,$arr_sender,$message,$validity_period = '86400') {
//Array of error states
$error_array = array (
'-1' => __('Not enough money'),
'-2' => __('Invalid username or password (authentication error)'),
'-3' => __('There is no text messages'),
'-4' => __('Invalid value of the recipient\'s number'),
'-5' => __('Invalid value of the sender\'s address'),
'-6' => __('No username'),
'-7' => __('No Password'),
'-10' => __('Service unavailable'),
'-11' => __('Invalid value message ID')
);
$msg_delivery='';
if (!is_array($arr_phone)) {
$phone=vf($arr_phone,3);
if (!empty($phone)) $msg_delivery.='<msg recipient="'.$phone.'" sender="'.((!is_string($arr_sender) OR empty($arr_sender))?$arr_config['sms_sender']:$arr_sender).'" validity_period="'.$validity_period.'">'.$message.'</msg>
';
} elseif (!empty($arr_phone[0])) {
foreach($arr_phone as $key=>$phone){
$phone=vf($phone,3);
if (!empty($phone)) $msg_delivery.='<msg recipient="'.$phone.'" sender="'.$arr_sender[$key].'" validity_period="'.$validity_period.'">'.$message.'</msg>
';
}
}
$url = $arr_config['sms_url'];
$ch = curl_init();
$request='<?xml version="1.0" encoding="utf-8" ?>
<package login="'.$arr_config['sms_user'].'" password="'.$arr_config['sms_password'].'">
<message>
<default sender="'.$arr_config['sms_sender'].'"/>
'.$msg_delivery.'
</message>
</package>';
log_register($request);

curl_setopt($ch, CURLOPT_URL,            $arr_config['sms_url'] );
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1 );
curl_setopt($ch, CURLOPT_POST,           1 );
curl_setopt($ch, CURLOPT_POSTFIELDS,     $request); 
curl_setopt($ch, CURLOPT_HTTPHEADER,     array('Content-Type: text/plain')); 

$html=curl_exec ($ch);
if (empty($html)) return show_window(__('Error'),__('Service unavailable'));
$xml = new SimpleXMLElement($html); 
$result = '';

if (isset($xml->msg)) {
foreach($xml->msg as $txt_msg){
$result.= __('Message sent').': ';
foreach ($txt_msg->attributes() as $key=>$value){
$result.= $key.'='.$value.'; ';
}
$result.='<br/>';
}
}

if (!empty($xml->error)) {
$result.=__('Error occurred').'. '.$error_array[$xml->error].'<br/>';
}

return $result;
}

//Read SMS configuration
$smsconfig = unserialize(file_get_contents(CONFIG_PATH.'sms.ini'));

if (fncfr()) {
//Save configuration
	if(isset($_POST['smsconfig'])) {
if (file_write_contents(CONFIG_PATH.'sms.ini' , serialize($_POST['smsconfig']))) {
		rcms_redirect('?module=fnsms&saved=true');
		} else show_window(__('Result'),__('Error occurred'));
	}

	
//Display a message that the settings are saved
if (get('saved')=='true') show_window(__('Result'),__('Configuration updated'));

if (empty($smsconfig['sms_url']) OR empty($smsconfig['sms_user']) OR empty($smsconfig['sms_password'])) {
show_window(__('SMS'),__('Configuration').': '.__('is not readable'));
} else {
//Send sms text to server and show answer
if (isset($_POST['message'])&&isset($_POST['phone_arr'])) {

$result=send_sms($smsconfig,$_POST['phone_arr'],$_POST['sender_arr'],$_POST['message']);

show_window(__('SMS').' '.__('status').': ',$result);
}

//Sender Form
$add_sms ='<div>'.__('Phone')." +<input type=\'text\' name=\'phone_arr[]\' size=\'25\' />*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".__('Sender').": <input type=\'text\' name=\'sender_arr[]\' size=\'15\' value=\'".$smsconfig['sms_sender']."\'/>&nbsp;<img src=\'".SKIN_PATH."fastnews/delete.gif\' style=\'cursor:pointer;\' onClick=\'$($(this).parents().get(0)).remove();\'></div>";
$frm =new InputForm ('', 'post', __('Submit'));
$frm->addrow(
__('Phone').' +'.$frm->text_box('phone_arr[]', post('phone_arr[0]'),25).'* ',
__('Sender').': '.$frm->text_box('sender_arr[]', (post('sender_arr[0]')?post('sender_arr[0]'):$smsconfig['sms_sender']),15)
.'&nbsp;<img style=\'cursor:pointer;\' onClick="$(\'#add_sms\').append(\''.$add_sms.'\');" src="'.SKIN_PATH.'fastnews/tag_small.gif"/>'
);
$frm->addmessage('<div id="add_sms"></div>');
$frm->addrow(
__('Message').'*: ',
$frm->textarea('message', post('message'), 45, 5)
);
$frm->addmessage('* - '.__('Required fields'));
show_window(__('Send').' '.__('SMS'),$frm->show(true));

}

//Show configuration
$frm =new InputForm ('?module=fnsms&act=conf', 'post', __('Submit'));
$frm->addbreak(__('General configuration'));
$frm->addrow(
__('URL').': '.$frm->text_box('smsconfig[sms_url]', @$smsconfig['sms_url'],55),
__('User').': '.$frm->text_box('smsconfig[sms_user]', @$smsconfig['sms_user'], 15)
);
$frm->addrow( 
__('Sender').': +'.$frm->text_box('smsconfig[sms_sender]', @$smsconfig['sms_sender'],25),
__('Password').': '.$frm->text_box('smsconfig[sms_password]', @$smsconfig['sms_password'], 15)
);

$frm->addbreak(__('Skins').' '.__('SMS'));
$frm->addrow(__('Unsuccessful attempt to pay').' '.fn_param_selector('smsconfig[unsuccess_pay]',@$smsconfig['unsuccess_pay'])
.' +'.__('Phone').' '.$frm->text_box('smsconfig[unsuccess_admin]', @$smsconfig['unsuccess_admin'], 15)
.'<br>'
.'{REALNAME}<br>'
.'{ITEMID}<br>'
.'{ITEMNAME}<br>'
.'{CURDATE}<br>'
.'{CASH}<br>'
.'{PHONE}<br>'
.'{EMAIL}<br>'
.'{DEFAULTSENDER}<br>'
.'{DATEIN}<br>'
.'{DATEOUT}<br>'
.'{ORDERNO}<br>'
, 
$frm->textarea('smsconfig[unsuccess_text]', @$smsconfig['unsuccess_text'], 44, 7), 'top');

$frm->addrow(__('Successful attempt to pay').' '.fn_param_selector('smsconfig[success_pay]',@$smsconfig['success_pay']) 
.' +'.__('Phone').' '.$frm->text_box('smsconfig[success_admin]', @$smsconfig['success_admin'], 15)
.'<br>'
.'{REALNAME}<br>'
.'{ITEMID}<br>'
.'{ITEMNAME}<br>'
.'{CURDATE}<br>'
.'{CASH}<br>'
.'{PHONE}<br>'
.'{EMAIL}<br>'
.'{DEFAULTSENDER}<br>'
.'{DATEIN}<br>'
.'{DATEOUT}<br>'
.'{ORDERNO}<br>'
, 
$frm->textarea('smsconfig[success_text]', @$smsconfig['success_text'], 44, 7), 'top');
show_window(__('Configuration').' '.__('SMS'), $frm->show(true));



}
?>